<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (123)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>libs:</p>
    <ul>
      <li>d3</li>
      <li>domtree</li>
    </ul>
    <hr />
    <h1 id="selection-and-range">Selection and Range</h1>
    <p>
      In this chapter we’ll cover selection in the document, as well as
      selection in form fields, such as <code>&lt;input&gt;</code>.
    </p>
    <p>
      JavaScript can access an existing selection, select/deselect DOM nodes as
      a whole or partially, remove the selected content from the document, wrap
      it into a tag, and so on.
    </p>
    <p>
      You can find some recipes for common tasks at the end of the chapter, in
      “Summary” section. Maybe that covers your current needs, but you’ll get
      much more if you read the whole text.
    </p>
    <p>
      The underlying <code>Range</code> and <code>Selection</code> objects are
      easy to grasp, and then you’ll need no recipes to make them do what you
      want.
    </p>
    <h2 id="range">Range</h2>
    <p>
      The basic concept of selection is
      <a href="https://dom.spec.whatwg.org/#ranges">Range</a>, that is
      essentially a pair of “boundary points”: range start and range end.
    </p>
    <p>A <code>Range</code> object is created without parameters:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> range <span class="op">=</span> <span class="kw">new</span> <span class="at">Range</span>()<span class="op">;</span></a></code></pre>
    </div>
    <p>
      Then we can set the selection boundaries using
      <code>range.setStart(node, offset)</code> and
      <code>range.setEnd(node, offset)</code>.
    </p>
    <p>
      As you might guess, further we’ll use the <code>Range</code> objects for
      selection, but first let’s create few such objects.
    </p>
    <h3 id="selecting-the-text-partially">Selecting the text partially</h3>
    <p>
      The interesting thing is that the first argument <code>node</code> in both
      methods can be either a text node or an element node, and the meaning of
      the second argument depends on that.
    </p>
    <p>
      <strong
        >If <code>node</code> is a text node, then <code>offset</code> must be
        the position in its text.</strong
      >
    </p>
    <p>
      For example, given the element <code>&lt;p&gt;Hello&lt;/p&gt;</code>, we
      can create the range containing the letters “ll” as follows:
    </p>
    ```html run
    <p id="p">Hello</p>
    <script>
      let range = new Range();
      range.setStart(p.firstChild, 2);
      range.setEnd(p.firstChild, 4);

      // toString of a range returns its content as text
      console.log(range); // ll
    </script>
    <p>```</p>
    <p>
      Here we take the first child of <code>&lt;p&gt;</code> (that’s the text
      node) and specify the text positions inside it:
    </p>
    <p><img src="range-hello-1.svg" /></p>
    <h3 id="selecting-element-nodes">Selecting element nodes</h3>
    <p>
      <strong
        >Alternatively, if <code>node</code> is an element node, then
        <code>offset</code> must be the child number.</strong
      >
    </p>
    <p>
      That’s handy for making ranges that contain nodes as a whole, not stop
      somewhere inside their text.
    </p>
    <p>For example, we have a more complex document fragment:</p>
    <p>
      <code
        >html autorun &lt;p id="p"&gt;Example: &lt;i&gt;italic&lt;/i&gt; and
        &lt;b&gt;bold&lt;/b&gt;&lt;/p&gt;</code
      >
    </p>
    <p>Here’s its DOM structure with both element and text nodes:</p>
    <div class="select-p-domtree"></div>
    <script>
      let selectPDomtree = {
        name: "P",
        nodeType: 1,
        children: [
          {
            name: "#text",
            nodeType: 3,
            content: "Example: ",
          },
          {
            name: "I",
            nodeType: 1,
            children: [
              {
                name: "#text",
                nodeType: 3,
                content: "italic",
              },
            ],
          },
          {
            name: "#text",
            nodeType: 3,
            content: " and ",
          },
          {
            name: "B",
            nodeType: 1,
            children: [
              {
                name: "#text",
                nodeType: 3,
                content: "bold",
              },
            ],
          },
        ],
      };

      drawHtmlTree(selectPDomtree, "div.select-p-domtree", 690, 320);
    </script>
    <p>
      Let’s make a range for <code>"Example: &lt;i&gt;italic&lt;/i&gt;"</code>.
    </p>
    <p>
      As we can see, this phrase consists of exactly two children of
      <code>&lt;p&gt;</code>, with indexes <code>0</code> and <code>1</code>:
    </p>
    <p><img src="range-example-p-0-1.svg" /></p>
    <ul>
      <li>
        <p>
          The starting point has <code>&lt;p&gt;</code> as the parent
          <code>node</code>, and <code>0</code> as the offset.
        </p>
        <p>So we can set it as <code>range.setStart(p, 0)</code>.</p>
      </li>
      <li>
        <p>
          The ending point also has <code>&lt;p&gt;</code> as the parent
          <code>node</code>, but <code>2</code> as the offset (it specifies the
          range up to, but not including <code>offset</code>).
        </p>
        <p>So we can set it as <code>range.setEnd(p, 2)</code>.</p>
      </li>
    </ul>
    <p>
      Here’s the demo. If you run it, you can see that the text gets selected:
    </p>
    ```html run
    <p id="p">Example: <i>italic</i> and <b>bold</b></p>
    <script>
      *!*
        let range = new Range();

        range.setStart(p, 0);
        range.setEnd(p, 2);
      */!*

        // toString of a range returns its content as text, without tags
        console.log(range); // Example: italic

        // apply this range for document selection (explained later below)
        document.getSelection().addRange(range);
    </script>
    <p>```</p>
    <p>
      Here’s a more flexible test stand where you can set range start/end
      numbers and explore other variants:
    </p>
    ```html run autorun
    <p id="p">Example: <i>italic</i> and <b>bold</b></p>
    From <input id="start" type="number" value="1" /> – To
    <input id="end" type="number" value="4" />
    <button id="button">Click to select</button>
    <script>
      button.onclick = () => {
      *!*
        let range = new Range();

        range.setStart(p, start.value);
        range.setEnd(p, end.value);
      */!*

        // apply the selection, explained later below
        document.getSelection().removeAllRanges();
        document.getSelection().addRange(range);
      };
    </script>
    <p>```</p>
    <p>
      E.g. selecting in the same <code>&lt;p&gt;</code> from offset
      <code>1</code> to <code>4</code> gives us the range
      <code>&lt;i&gt;italic&lt;/i&gt; and &lt;b&gt;bold&lt;/b&gt;</code>:
    </p>
    <p><img src="range-example-p-1-3.svg" /></p>
    <p>
      <code
        >smart header="Starting and ending nodes can be different" We don't have
        to use the same node in `setStart` and `setEnd`. A range may span across
        many unrelated nodes. It's only important that the end is after the
        start in the document.</code
      >
    </p>
    <h3 id="selecting-a-bigger-fragment">Selecting a bigger fragment</h3>
    <p>Let’s make a bigger selection in our example, like this:</p>
    <p><img src="range-example-p-2-b-3.svg" /></p>
    <p>
      We already know how to do that. We just need to set the start and the end
      as a relative offset in text nodes.
    </p>
    <p>We need to create a range, that:</p>
    <ul>
      <li>
        starts from position 2 in <code>&lt;p&gt;</code> first child (taking all
        but two first letters of “Ex<b>ample:</b>”)
      </li>
      <li>
        ends at the position 3 in <code>&lt;b&gt;</code> first child (taking
        first three letters of “<b>bol</b>d”, but no more):
      </li>
    </ul>
    ```html run
    <p id="p">Example: <i>italic</i> and <b>bold</b></p>
    <script>
      let range = new Range();

      range.setStart(p.firstChild, 2);
      range.setEnd(p.querySelector("b").firstChild, 3);

      console.log(range); // ample: italic and bol

      // use this range for selection (explained later)
      window.getSelection().addRange(range);
    </script>
    <p>```</p>
    <p>As you can see, it’s fairly easy to make a range of whatever we want.</p>
    <p>
      If we’d like to take nodes as a whole, we can pass elements in
      <code>setStart/setEnd</code>. Otherwise, we can work on the text level.
    </p>
    <h2 id="range-properties">Range properties</h2>
    <p>
      The range object that we created in the example above has following
      properties:
    </p>
    <p><img src="range-example-p-2-b-3-range.svg" /></p>
    <ul>
      <li>
        <code>startContainer</code>, <code>startOffset</code> – node and offset
        of the start,
        <ul>
          <li>
            in the example above: first text node inside
            <code>&lt;p&gt;</code> and <code>2</code>.
          </li>
        </ul>
      </li>
      <li>
        <code>endContainer</code>, <code>endOffset</code> – node and offset of
        the end,
        <ul>
          <li>
            in the example above: first text node inside
            <code>&lt;b&gt;</code> and <code>3</code>.
          </li>
        </ul>
      </li>
      <li>
        <code>collapsed</code> – boolean, <code>true</code> if the range starts
        and ends on the same point (so there’s no content inside the range),
        <ul>
          <li>in the example above: <code>false</code></li>
        </ul>
      </li>
      <li>
        <code>commonAncestorContainer</code> – the nearest common ancestor of
        all nodes within the range,
        <ul>
          <li>in the example above: <code>&lt;p&gt;</code></li>
        </ul>
      </li>
    </ul>
    <h2 id="range-selection-methods">Range selection methods</h2>
    <p>There are many convenience methods to manipulate ranges.</p>
    <p>
      We’ve already seen <code>setStart</code> and <code>setEnd</code>, here are
      other similar methods.
    </p>
    <p>Set range start:</p>
    <ul>
      <li>
        <code>setStart(node, offset)</code> set start at: position
        <code>offset</code> in <code>node</code>
      </li>
      <li>
        <code>setStartBefore(node)</code> set start at: right before
        <code>node</code>
      </li>
      <li>
        <code>setStartAfter(node)</code> set start at: right after
        <code>node</code>
      </li>
    </ul>
    <p>Set range end (similar methods):</p>
    <ul>
      <li>
        <code>setEnd(node, offset)</code> set end at: position
        <code>offset</code> in <code>node</code>
      </li>
      <li>
        <code>setEndBefore(node)</code> set end at: right before
        <code>node</code>
      </li>
      <li>
        <code>setEndAfter(node)</code> set end at: right after <code>node</code>
      </li>
    </ul>
    <p>
      Technically, <code>setStart/setEnd</code> can do anything, but more
      methods provide more convenience.
    </p>
    <p>
      In all these methods, <code>node</code> can be both a text or element
      node: for text nodes <code>offset</code> skips that many of characters,
      while for element nodes that many child nodes.
    </p>
    <p>Even more methods to create ranges:</p>
    <ul>
      <li>
        <code>selectNode(node)</code> set range to select the whole
        <code>node</code>
      </li>
      <li>
        <code>selectNodeContents(node)</code> set range to select the whole
        <code>node</code> contents
      </li>
      <li>
        <code>collapse(toStart)</code> if <code>toStart=true</code> set
        end=start, otherwise set start=end, thus collapsing the range
      </li>
      <li>
        <code>cloneRange()</code> creates a new range with the same start/end
      </li>
    </ul>
    <h2 id="range-editing-methods">Range editing methods</h2>
    <p>
      Once the range is created, we can manipulate its content using these
      methods:
    </p>
    <ul>
      <li>
        <code>deleteContents()</code> – remove range content from the document
      </li>
      <li>
        <code>extractContents()</code> – remove range content from the document
        and return as
        <a href="info:modifying-document#document-fragment">DocumentFragment</a>
      </li>
      <li>
        <code>cloneContents()</code> – clone range content and return as
        <a href="info:modifying-document#document-fragment">DocumentFragment</a>
      </li>
      <li>
        <code>insertNode(node)</code> – insert <code>node</code> into the
        document at the beginning of the range
      </li>
      <li>
        <code>surroundContents(node)</code> – wrap <code>node</code> around
        range content. For this to work, the range must contain both opening and
        closing tags for all elements inside it: no partial ranges like
        <code>&lt;i&gt;abc</code>.
      </li>
    </ul>
    <p>With these methods we can do basically anything with selected nodes.</p>
    <p>Here’s the test stand to see them in action:</p>
    <p>
      ```html run refresh autorun height=260 Click buttons to run methods on the
      selection, “resetExample” to reset it.
    </p>
    <p id="p">Example: <i>italic</i> and <b>bold</b></p>
    <p id="result"></p>
    <script>
      let range = new Range();

      // Each demonstrated method is represented here:
      let methods = {
        deleteContents() {
          range.deleteContents();
        },
        extractContents() {
          let content = range.extractContents();
          result.innerHTML = "";
          result.append("extracted: ", content);
        },
        cloneContents() {
          let content = range.cloneContents();
          result.innerHTML = "";
          result.append("cloned: ", content);
        },
        insertNode() {
          let newNode = document.createElement("u");
          newNode.innerHTML = "NEW NODE";
          range.insertNode(newNode);
        },
        surroundContents() {
          let newNode = document.createElement("u");
          try {
            range.surroundContents(newNode);
          } catch (e) {
            console.log(e);
          }
        },
        resetExample() {
          p.innerHTML = `Example: <i>italic</i> and <b>bold</b>`;
          result.innerHTML = "";

          range.setStart(p.firstChild, 2);
          range.setEnd(p.querySelector("b").firstChild, 3);

          window.getSelection().removeAllRanges();
          window.getSelection().addRange(range);
        },
      };

      for (let method in methods) {
        document.write(
          `<div><button onclick="methods.${method}()">${method}</button></div>`
        );
      }

      methods.resetExample();
    </script>
    <p>```</p>
    <p>
      There also exist methods to compare ranges, but these are rarely used.
      When you need them, please refer to the
      <a href="https://dom.spec.whatwg.org/#interface-range">spec</a> or
      <a href="mdn:/api/Range">MDN manual</a>.
    </p>
    <h2 id="selection">Selection</h2>
    <p>
      <code>Range</code> is a generic object for managing selection ranges.
      Although, creating a <code>Range</code> doesn’t mean that we see a
      selection on screen.
    </p>
    <p>
      We may create <code>Range</code> objects, pass them around – they do not
      visually select anything on their own.
    </p>
    <p>
      The document selection is represented by <code>Selection</code> object,
      that can be obtained as <code>window.getSelection()</code> or
      <code>document.getSelection()</code>. A selection may include zero or more
      ranges. At least, the
      <a href="https://www.w3.org/TR/selection-api/"
        >Selection API specification</a
      >
      says so. In practice though, only Firefox allows to select multiple ranges
      in the document by using <code>key:Ctrl+click</code> (<code
        >key:Cmd+click</code
      >
      for Mac).
    </p>
    <p>Here’s a screenshot of a selection with 3 ranges, made in Firefox:</p>
    <p><img src="selection-firefox.svg" /></p>
    <p>
      Other browsers support at maximum 1 range. As we’ll see, some of
      <code>Selection</code> methods imply that there may be many ranges, but
      again, in all browsers except Firefox, there’s at maximum 1.
    </p>
    <p>
      Here’s a small demo that shows the current selection (select something and
      click) as text:
    </p>
    <button onclick="alert(document.getSelection())">
      alert(document.getSelection())
    </button>
    <h2 id="selection-properties">Selection properties</h2>
    <p>
      As said, a selection may in theory contain multiple ranges. We can get
      these range objects using the method:
    </p>
    <ul>
      <li>
        <code>getRangeAt(i)</code> – get i-th range, starting from
        <code>0</code>. In all browsers except Firefox, only <code>0</code> is
        used.
      </li>
    </ul>
    <p>Also, there exist properties that often provide better convenience.</p>
    <p>
      Similar to a range, a selection object has a start, called “anchor”, and
      the end, called “focus”.
    </p>
    <p>The main selection properties are:</p>
    <ul>
      <li><code>anchorNode</code> – the node where the selection starts,</li>
      <li>
        <code>anchorOffset</code> – the offset in <code>anchorNode</code> where
        the selection starts,
      </li>
      <li><code>focusNode</code> – the node where the selection ends,</li>
      <li>
        <code>focusOffset</code> – the offset in <code>focusNode</code> where
        the selection ends,
      </li>
      <li>
        <code>isCollapsed</code> – <code>true</code> if selection selects
        nothing (empty range), or doesn’t exist.
      </li>
      <li>
        <code>rangeCount</code> – count of ranges in the selection, maximum
        <code>1</code> in all browsers except Firefox.
      </li>
    </ul>
    <p>```smart header=“Selection end/start vs Range”</p>
    <p>
      There’s an important differences of a selection anchor/focus compared with
      a <code>Range</code> start/end.
    </p>
    <p>
      As we know, <code>Range</code> objects always have their start before the
      end.
    </p>
    <p>For selections, that’s not always the case.</p>
    <p>
      Selecting something with a mouse can be done in both directions: either
      “left-to-right” or “right-to-left”.
    </p>
    <p>
      In other words, when the mouse button is pressed, and then it moves
      forward in the document, then its end (focus) will be after its start
      (anchor).
    </p>
    <p>
      E.g. if the user starts selecting with mouse and goes from “Example” to
      “italic”:
    </p>
    <p><img src="selection-direction-forward.svg" /></p>
    <p>
      …But the same selection could be done backwards: starting from “italic” to
      “Example” (backward direction), then its end (focus) will be before the
      start (anchor):
    </p>
    <p><img src="selection-direction-backward.svg" /> ```</p>
    <h2 id="selection-events">Selection events</h2>
    <p>There are events on to keep track of selection:</p>
    <ul>
      <li>
        <code>elem.onselectstart</code> – when a selection
        <em>starts</em> specifically on element <code>elem</code> (or inside
        it). For instance, when the user presses the mouse button on it and
        starts to move the pointer.
        <ul>
          <li>
            Preventing the default action cancels the selection start. So
            starting a selection from this element becomes impossible, but the
            element is still selectable. The visitor just needs to start the
            selection from elsewhere.
          </li>
        </ul>
      </li>
      <li>
        <code>document.onselectionchange</code> – whenever a selection changes
        or starts.
        <ul>
          <li>
            Please note: this handler can be set only on <code>document</code>,
            it tracks all selections in it.
          </li>
        </ul>
      </li>
    </ul>
    <h3 id="selection-tracking-demo">Selection tracking demo</h3>
    <p>
      Here’s a small demo. It tracks the current selection on the
      <code>document</code> and shows its boundaries:
    </p>
    ```html run height=80
    <p id="p">Select me: <i>italic</i> and <b>bold</b></p>
    From <input id="from" disabled /> – To <input id="to" disabled />
    <script>
      document.onselectionchange = function () {
        let selection = document.getSelection();

        let { anchorNode, anchorOffset, focusNode, focusOffset } = selection;

        // anchorNode and focusNode are text nodes usually
        from.value = `${anchorNode?.data}, offset ${anchorOffset}`;
        to.value = `${focusNode?.data}, offset ${focusOffset}`;
      };
    </script>
    <p>```</p>
    <h3 id="selection-copying-demo">Selection copying demo</h3>
    <p>There are two approaches to copying the selected content:</p>
    <ol type="1">
      <li>
        We can use <code>document.getSelection().toString()</code> to get it as
        text.
      </li>
      <li>
        Otherwise, to copy the full DOM, e.g. if we need to keep formatting, we
        can get the underlying ranges with <code>getRangesAt(...)</code>. A
        <code>Range</code> object, in turn, has
        <code>cloneContents()</code> method that clones its content and returns
        as <code>DocumentFragment</code> object, that we can insert elsewhere.
      </li>
    </ol>
    <p>
      Here’s the demo of copying the selected content both as text and as DOM
      nodes:
    </p>
    ```html run height=100
    <p id="p">Select me: <i>italic</i> and <b>bold</b></p>
    <p>
      Cloned: <span id="cloned"></span> <br />
      As text: <span id="astext"></span>
    </p>
    <script>
      document.onselectionchange = function () {
        let selection = document.getSelection();

        cloned.innerHTML = astext.innerHTML = "";

        // Clone DOM nodes from ranges (we support multiselect here)
        for (let i = 0; i < selection.rangeCount; i++) {
          cloned.append(selection.getRangeAt(i).cloneContents());
        }

        // Get as text
        astext.innerHTML += selection;
      };
    </script>
    <p>```</p>
    <h2 id="selection-methods">Selection methods</h2>
    <p>We can work with the selection by addding/removing ranges:</p>
    <ul>
      <li>
        <code>getRangeAt(i)</code> – get i-th range, starting from
        <code>0</code>. In all browsers except Firefox, only <code>0</code> is
        used.
      </li>
      <li>
        <code>addRange(range)</code> – add <code>range</code> to selection. All
        browsers except Firefox ignore the call, if the selection already has an
        associated range.
      </li>
      <li>
        <code>removeRange(range)</code> – remove <code>range</code> from the
        selection.
      </li>
      <li><code>removeAllRanges()</code> – remove all ranges.</li>
      <li><code>empty()</code> – alias to <code>removeAllRanges</code>.</li>
    </ul>
    <p>
      There are also convenience methods to manipulate the selection range
      directly, without intermediate <code>Range</code> calls:
    </p>
    <ul>
      <li>
        <code>collapse(node, offset)</code> – replace selected range with a new
        one that starts and ends at the given <code>node</code>, at position
        <code>offset</code>.
      </li>
      <li>
        <code>setPosition(node, offset)</code> – alias to <code>collapse</code>.
      </li>
      <li>
        <code>collapseToStart()</code> - collapse (replace with an empty range)
        to selection start,
      </li>
      <li><code>collapseToEnd()</code> - collapse to selection end,</li>
      <li>
        <code>extend(node, offset)</code> - move focus of the selection to the
        given <code>node</code>, position <code>offset</code>,
      </li>
      <li>
        <code
          >setBaseAndExtent(anchorNode, anchorOffset, focusNode,
          focusOffset)</code
        >
        - replace selection range with the given start
        <code>anchorNode/anchorOffset</code> and end
        <code>focusNode/focusOffset</code>. All content in-between them is
        selected.
      </li>
      <li>
        <code>selectAllChildren(node)</code> – select all children of the
        <code>node</code>.
      </li>
      <li>
        <code>deleteFromDocument()</code> – remove selected content from the
        document.
      </li>
      <li>
        <code>containsNode(node, allowPartialContainment = false)</code> –
        checks whether the selection contains <code>node</code> (partially if
        the second argument is <code>true</code>)
      </li>
    </ul>
    <p>
      For most tasks these methods are just fine, there’s no need to access the
      underlying <code>Range</code> object.
    </p>
    <p>
      For example, selecting the whole contents of the paragraph
      <code>&lt;p&gt;</code>:
    </p>
    ```html run
    <p id="p">Select me: <i>italic</i> and <b>bold</b></p>
    <script>
      // select from 0th child of <p> to the last child
      document.getSelection().setBaseAndExtent(p, 0, p, p.childNodes.length);
    </script>
    <p>```</p>
    <p>The same thing using ranges:</p>
    ```html run
    <p id="p">Select me: <i>italic</i> and <b>bold</b></p>
    <script>
      let range = new Range();
      range.selectNodeContents(p); // or selectNode(p) to select the <p> tag too

      document.getSelection().removeAllRanges(); // clear existing selection if any
      document.getSelection().addRange(range);
    </script>
    <p>```</p>
    <p>
      ``<code
        >smart header="To select something, remove the existing selection first"
        If a document selection already exists, empty it first with</code
      >removeAllRanges()`. And then add ranges. Otherwise, all browsers except
      Firefox ignore new ranges.
    </p>
    <p>
      The exception is some selection methods, that replace the existing
      selection, such as <code>setBaseAndExtent</code>. ```
    </p>
    <h2 id="selection-in-form-controls">Selection in form controls</h2>
    <p>
      Form elements, such as <code>input</code> and
      <code>textarea</code> provide
      <a href="https://html.spec.whatwg.org/#textFieldSelection"
        >special API for selection</a
      >, without <code>Selection</code> or <code>Range</code> objects. As an
      input value is a pure text, not HTML, there’s no need for such objects,
      everything’s much simpler.
    </p>
    <p>Properties:</p>
    <ul>
      <li>
        <code>input.selectionStart</code> – position of selection start
        (writeable),
      </li>
      <li>
        <code>input.selectionEnd</code> – position of selection end (writeable),
      </li>
      <li>
        <code>input.selectionDirection</code> – selection direction, one of:
        “forward”, “backward” or “none” (if e.g. selected with a double mouse
        click),
      </li>
    </ul>
    <p>Events:</p>
    <ul>
      <li>
        <code>input.onselect</code> – triggers when something is selected.
      </li>
    </ul>
    <p>Methods:</p>
    <ul>
      <li>
        <code>input.select()</code> – selects everything in the text control
        (can be <code>textarea</code> instead of <code>input</code>),
      </li>
      <li>
        <code>input.setSelectionRange(start, end, [direction])</code> – change
        the selection to span from position <code>start</code> till
        <code>end</code>, in the given direction (optional).
      </li>
      <li>
        <p>
          <code
            >input.setRangeText(replacement, [start], [end],
            [selectionMode])</code
          >
          – replace a range of text with the new text.
        </p>
        <p>
          Optional arguments <code>start</code> and <code>end</code>, if
          provided, set the range start and end, otherwise user selection is
          used.
        </p>
        <p>
          The last argument, <code>selectionMode</code>, determines how the
          selection will be set after the text has been replaced. The possible
          values are:
        </p>
        <ul>
          <li>
            <code>"select"</code> – the newly inserted text will be selected.
          </li>
          <li>
            <code>"start"</code> – the selection range collapses just before the
            inserted text (the cursor will be immediately before it).
          </li>
          <li>
            <code>"end"</code> – the selection range collapses just after the
            inserted text (the cursor will be right after it).
          </li>
          <li>
            <code>"preserve"</code> – attempts to preserve the selection. This
            is the default.
          </li>
        </ul>
      </li>
    </ul>
    <p>Now let’s see these methods in action.</p>
    <h3 id="example-tracking-selection">Example: tracking selection</h3>
    <p>
      For example, this code uses <code>onselect</code> event to track
      selection:
    </p>
    ```html run autorun
    <textarea id="area" style="width: 80%; height: 60px">
Selecting in this text updates values below.
</textarea
    >
    <p>
      <br />
      From <input id="from" disabled /> – To <input id="to" disabled />
    </p>
    <script>
      area.onselect = function () {
        from.value = area.selectionStart;
        to.value = area.selectionEnd;
      };
    </script>
    <p>```</p>
    <p>Please note:</p>
    <ul>
      <li>
        <code>onselect</code> triggers when something is selected, but not when
        the selection is removed.
      </li>
      <li>
        <code>document.onselectionchange</code> event should not trigger for
        selections inside a form control, according to the
        <a href="https://w3c.github.io/selection-api/#dfn-selectionchange"
          >spec</a
        >, as it’s not related to <code>document</code> selection and ranges.
        Some browsers generate it, but we shouldn’t rely on it.
      </li>
    </ul>
    <h3 id="example-moving-cursor">Example: moving cursor</h3>
    <p>
      We can change <code>selectionStart</code> and <code>selectionEnd</code>,
      that sets the selection.
    </p>
    <p>
      An important edge case is when <code>selectionStart</code> and
      <code>selectionEnd</code> equal each other. Then it’s exactly the cursor
      position. Or, to rephrase, when nothing is selected, the selection is
      collapsed at the cursor position.
    </p>
    <p>
      So, by setting <code>selectionStart</code> and
      <code>selectionEnd</code> to the same value, we move the cursor.
    </p>
    <p>For example:</p>
    ```html run autorun
    <textarea id="area" style="width: 80%; height: 60px">
Focus on me, the cursor will be at position 10.
</textarea
    >
    <script>
      area.onfocus = () => {
        // zero delay setTimeout to run after browser "focus" action finishes
        setTimeout(() => {
          // we can set any selection
          // if start=end, the cursor is exactly at that place
          area.selectionStart = area.selectionEnd = 10;
        });
      };
    </script>
    <p>```</p>
    <h3 id="example-modifying-selection">Example: modifying selection</h3>
    <p>
      To modify the content of the selection, we can use
      <code>input.setRangeText()</code> method. Of course, we can read
      <code>selectionStart/End</code> and, with the knowledge of the selection,
      change the corresponding substring of <code>value</code>, but
      <code>setRangeText</code> is more powerful and often more convenient.
    </p>
    <p>
      That’s a somewhat complex method. In its simplest one-argument form it
      replaces the user selected range and removes the selection.
    </p>
    <p>
      For example, here the user selection will be wrapped by
      <code>*...*</code>:
    </p>
    <p>
      ```html run autorun
      <input
        id="input"
        style="width: 200px"
        value="Select here and click the button"
      />
      <button id="button">Wrap selection in stars <em>…</em></button>
    </p>
    <script>
      button.onclick = () => {
        if (input.selectionStart == input.selectionEnd) {
          return; // nothing is selected
        }

        let selected = input.value.slice(
          input.selectionStart,
          input.selectionEnd
        );
        input.setRangeText(`*${selected}*`);
      };
    </script>
    <p>```</p>
    <p>
      With more arguments, we can set range <code>start</code> and
      <code>end</code>.
    </p>
    <p>
      In this example we find <code>"THIS"</code> in the input text, replace it
      and keep the replacement selected:
    </p>
    <p>
      ```html run autorun
      <input id="input" style="width: 200px" value="Replace THIS in text" />
      <button id="button">Replace THIS</button>
    </p>
    <script>
      button.onclick = () => {
        let pos = input.value.indexOf("THIS");
        if (pos >= 0) {
          input.setRangeText("*THIS*", pos, pos + 4, "select");
          input.focus(); // focus to make selection visible
        }
      };
    </script>
    <p>```</p>
    <h3 id="example-insert-at-cursor">Example: insert at cursor</h3>
    <p>
      If nothing is selected, or we use equal <code>start</code> and
      <code>end</code> in <code>setRangeText</code>, then the new text is just
      inserted, nothing is removed.
    </p>
    <p>
      We can also insert something “at the cursor” using
      <code>setRangeText</code>.
    </p>
    <p>
      Here’s a button that inserts <code>"HELLO"</code> at the cursor position
      and puts the cursor immediately after it. If the selection is not empty,
      then it gets replaced (we can detect it by comparing
      <code>selectionStart!=selectionEnd</code> and do something else instead):
    </p>
    <p>
      ```html run autorun
      <input id="input" style="width: 200px" value="Text Text Text Text Text" />
      <button id="button">Insert “HELLO” at cursor</button>
    </p>
    <script>
      button.onclick = () => {
        input.setRangeText(
          "HELLO",
          input.selectionStart,
          input.selectionEnd,
          "end"
        );
        input.focus();
      };
    </script>
    <p>```</p>
    <h2 id="making-unselectable">Making unselectable</h2>
    <p>To make something unselectable, there are three ways:</p>
    <ol type="1">
      <li>
        <p>Use CSS property <code>user-select: none</code>.</p>
        <p>
          <code
            >html run &lt;style&gt; #elem { user-select: none; } &lt;/style&gt;
            &lt;div&gt; Selectable &lt;div id="elem"&gt;Unselectable&lt;/div&gt;
            Selectable &lt;/div&gt;</code
          >
        </p>
        <p>
          This doesn’t allow the selection to start at <code>elem</code>. But
          the user may start the selection elsewhere and include
          <code>elem</code> into it.
        </p>
        <p>
          Then <code>elem</code> will become a part of
          <code>document.getSelection()</code>, so the selection actually
          happens, but its content is usually ignored in copy-paste.
        </p>
      </li>
      <li>
        <p>
          Prevent default action in <code>onselectstart</code> or
          <code>mousedown</code> events.
        </p>
        ```html run
        <div>
          Selectable
          <div id="elem">Unselectable</div>
          <p>Selectable</p>
        </div>
        <script>
          elem.onselectstart = () => false;
        </script>
        <p>```</p>
        <p>
          This prevents starting the selection on <code>elem</code>, but the
          visitor may start it at another element, then extend to
          <code>elem</code>.
        </p>
        <p>
          That’s convenient when there’s another event handler on the same
          action that triggers the select (e.g. <code>mousedown</code>). So we
          disable the selection to avoid conflict, still allowing
          <code>elem</code> contents to be copied.
        </p>
      </li>
      <li>
        <p>
          We can also clear the selection post-factum after it happens with
          <code>document.getSelection().empty()</code>. That’s rarely used, as
          this causes unwanted blinking as the selection appears-disappears.
        </p>
      </li>
    </ol>
    <h2 id="references">References</h2>
    <ul>
      <li><a href="https://dom.spec.whatwg.org/#ranges">DOM spec: Range</a></li>
      <li>
        <a
          href="https://www.w3.org/TR/selection-api/#dom-globaleventhandlers-onselectstart"
          >Selection API</a
        >
      </li>
      <li>
        <a
          href="https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#textFieldSelection"
          >HTML spec: APIs for the text control selections</a
        >
      </li>
    </ul>
    <h2 id="summary">Summary</h2>
    <p>We covered two different APIs for selections:</p>
    <ol type="1">
      <li>
        For document: <code>Selection</code> and <code>Range</code> objects.
      </li>
      <li>
        For <code>input</code>, <code>textarea</code>: additional methods and
        properties.
      </li>
    </ol>
    <p>The second API is very simple, as it works with text.</p>
    <p>The most used recipes are probably:</p>
    <ol type="1">
      <li>
        <p>Getting the selection:</p>
        <div class="sourceCode" id="cb2">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">let</span> selection <span class="op">=</span> <span class="va">document</span>.<span class="at">getSelection</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb2-2" title="2"></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="kw">let</span> cloned <span class="op">=</span> <span class="co">/* element to clone the selected nodes to */</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-4" title="4"></a>
<a class="sourceLine" id="cb2-5" title="5"><span class="co">// then apply Range methods to selection.getRangeAt(0)</span></a>
<a class="sourceLine" id="cb2-6" title="6"><span class="co">// or, like here, to all ranges to support multi-select</span></a>
<a class="sourceLine" id="cb2-7" title="7"><span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="va">selection</span>.<span class="at">rangeCount</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-8" title="8">  <span class="va">cloned</span>.<span class="at">append</span>(<span class="va">selection</span>.<span class="at">getRangeAt</span>(i).<span class="at">cloneContents</span>())<span class="op">;</span></a>
<a class="sourceLine" id="cb2-9" title="9"><span class="op">}</span></a></code></pre>
        </div>
      </li>
      <li>
        <p>Setting the selection:</p>
        <div class="sourceCode" id="cb3">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">let</span> selection <span class="op">=</span> <span class="va">document</span>.<span class="at">getSelection</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb3-2" title="2"></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="co">// directly:</span></a>
<a class="sourceLine" id="cb3-4" title="4"><span class="va">selection</span>.<span class="at">setBaseAndExtent</span>(...<span class="va">from</span>...<span class="va">to</span>...)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-5" title="5"></a>
<a class="sourceLine" id="cb3-6" title="6"><span class="co">// or we can create a range and:</span></a>
<a class="sourceLine" id="cb3-7" title="7"><span class="va">selection</span>.<span class="at">removeAllRanges</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb3-8" title="8"><span class="va">selection</span>.<span class="at">addRange</span>(range)<span class="op">;</span></a></code></pre>
        </div>
      </li>
    </ol>
    <p>
      And finally, about the cursor. The cursor position in editable elements,
      like <code>&lt;textarea&gt;</code> is always at the start or the end of
      the selection. We can use it to get cursor position or to move the cursor
      by setting <code>elem.selectionStart</code> and
      <code>elem.selectionEnd</code>.
    </p>
  </body>
</html>
